unit uMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  System.Messaging,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,

  FMX.Helpers.Android,
  Androidapi.Helpers,
  Androidapi.JNI.GraphicsContentViewText,
  Androidapi.JNI.JavaTypes, FMX.Layouts, FMX.Memo, FMX.StdCtrls,


  Androidapi.Jni,
  Androidapi.JNIBridge,
  Androidapi.JNI.PlayServices,
  System.Messaging,
  Androidapi.JNI.App, IPPeerClient, REST.Client, Data.Bind.Components,
  Data.Bind.ObjectScope, FMX.Objects, FMX.Effects;

type
  TForm2 = class(TForm)
    btnAuth: TButton;
    btnUserInfo: TButton;
    lbl1: TLabel;
    restClient: TRESTClient;
    restResponse: TRESTResponse;
    restRequest: TRESTRequest;
    rctngl1: TRectangle;
    rctngl2: TRectangle;
    rctngl3: TRectangle;
    shdwfct: TShadowEffect;
    GridPanelLayout1: TGridPanelLayout;
    Text1: TText;
    procedure btnAuthClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnUserInfoClick(Sender: TObject);
  private
    { Private declarations }
  public
    FMessageSubscriptionID : integer;
    FToken : string;
    procedure HandleActivityMessage(const Sender: TObject; const M: TMessage);
    function OnActivityResult(RequestCode, ResultCode: Integer; Data: JIntent): Boolean;
    function GetIntentFacebook : JIntent;
    { Public declarations }
  end;
const
    AppKey = '779727288766268';
    FacebookAppName = 'com.facebook.katana';
    FacebookActivityName = 'com.facebook.katana.ProxyAuth';
    FacebookScope = 'user_about_me,user_birthday, email';
    FacebookInfoUrl = 'https://graph.facebook.com/v2.2/me?fields=id,name&access_token=';
var
  Form2: TForm2;

implementation

{$R *.fmx}
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
procedure TForm2.btnAuthClick(Sender: TObject);
var
    Intent : JIntent;
    PM : JPackageManager;
    list : JList;
    count, i : integer;
    temp : string;
begin
    Intent := GetIntentFacebook;
    PM := SharedActivity.getPackageManager;
    list := PM.queryIntentActivities(Intent, 0);

    count := list.size;
    if count > 0 then
    begin
        self.lbl1.Text := 'Facebook App start';
        SharedActivity.startActivityForResult(Intent, 0);
    end
    else
    begin
        self.lbl1.Text := 'Facebook App Not Found';
    end;
end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
function TForm2.GetIntentFacebook: JIntent;
var
    Intent : JIntent;
    NativeComponent : JComponentName;
    PM : JPackageManager;
    list : JList;
    ResolveInfo : JResolveInfo;
    count, i : integer;
    temp : string;
begin
    Intent := TJIntent.Create;

    NativeComponent := TJComponentName.JavaClass.init(
    StringToJString(FacebookAppName),
    StringToJString(FacebookActivityName));
    Intent.setComponent(NativeComponent);
    Intent.putExtra(StringToJString('client_id'), StringToJString(AppKey));
    Intent.putExtra(StringToJString('scope'), StringToJString(FacebookScope));
    Result := Intent;
end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
procedure TForm2.btnUserInfoClick(Sender: TObject);
begin
    restClient.BaseURL := FacebookInfoUrl + FToken;
    restRequest.Execute;
    mmoLog.Text := mmoLog.Text + #13#10 + TimeToStr(Now) + #13#10 + restResponse.Content;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
    FMessageSubscriptionID :=
        TMessageManager.DefaultManager.SubscribeToMessage(TMessageResultNotification,
        HandleActivityMessage);
end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
procedure TForm2.HandleActivityMessage(const Sender: TObject;
  const M: TMessage);
begin
    if M is TMessageResultNotification then
        OnActivityResult(TMessageResultNotification(M).RequestCode, TMessageResultNotification(M).ResultCode,
            TMessageResultNotification(M).Value);
end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
function TForm2.OnActivityResult(RequestCode, ResultCode: Integer;
  Data: JIntent): Boolean;
var
   // rt : JGoogleAuthUtilClass;
    ScanContent: string;
    temp : string;
begin
    Result := False;
    TMessageManager.DefaultManager.Unsubscribe(TMessageResultNotification,
    FMessageSubscriptionID);
    if ResultCode = TJActivity.JavaClass.RESULT_OK then
    begin
        btnAuth.Enabled := false;
        btnUserInfo.Enabled := true;
        self.lbl1.Text := 'RESULT_OK';
        if Assigned(Data) then
        begin
            ScanContent := JStringToString(Data.getStringExtra(StringToJString('access_token')));
            FToken := ScanContent;
            self.mmoLog.Text := TimeToStr(Now) + #13#10 + ScanContent;
        end;
    end
    else
        if ResultCode = TJActivity.JavaClass.RESULT_CANCELED then
        begin
            self.lbl1.Text := 'RESULT_CANCELED';
            self.mmoLog.Text := TimeToStr(Now);
        end;
    Result := True;
end;
{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
end.
